//
//  ViewController.m
//  TouchIdDemo
//
//  Created by Mobisoft on 12/24/14.
//  Copyright (c) 2014 MIPL. All rights reserved.
//

#import "ViewController.h"
#import <LocalAuthentication/LocalAuthentication.h>


@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    [self addAuthenticateUser];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
    
    
    // Configure the session to produce lower resolution video frames, if your
    // processing algorithm can cope. We'll specify medium quality for the
    // chosen device.
    
    
}

- (void)addAuthenticateUser {
    
    
    UIButton *button =  [UIButton buttonWithType:UIButtonTypeCustom];
    
    [button setFrame:CGRectMake((self.view.frame.size.width/2)-50, (self.view.frame.size.height/2)-25, 100, 50)];
    
    [self.view addSubview:button];
    
    [button setTitle:@"TouchId" forState:UIControlStateNormal];
    
    [button setTitleColor:[UIColor  whiteColor] forState:UIControlStateNormal];
     
    [button setBackgroundColor:[UIColor grayColor]];
    
    [button addTarget:self action:@selector(authenticateButtonTabbed) forControlEvents:UIControlEventTouchUpInside];
    
}

- (void)authenticateButtonTabbed {
    
    LAContext *context = [[LAContext alloc] init];
    
    NSError *error = nil;
    
    if ([context canEvaluatePolicy:LAPolicyDeviceOwnerAuthenticationWithBiometrics error:&error]) {
        // Authenticate User
        
        [context evaluatePolicy:LAPolicyDeviceOwnerAuthenticationWithBiometrics
                localizedReason:@"Are you the device owner?"
                          reply:^(BOOL success, NSError *error) {
                              
                              if (success) {
                                  
                                  
                              } else {
                                  
                                  switch (error.code) {
                                          
                                      case LAErrorAuthenticationFailed:
                                          
                                          NSLog(@"Authentication was not successful, because user failed to provide valid credentials.");
                                          
                                          break;
                                          
                                      case LAErrorUserCancel:
                                          
                                          NSLog(@"Authentication was canceled by user");
                                          
                                          break;
                                          
                                      case LAErrorUserFallback:
                                          
                                          NSLog(@"Authentication was canceled, because the user tapped the password button");
                                          
                                          break;
                                          
                                      case LAErrorSystemCancel:
                                          
                                          NSLog(@"Authentication was canceled by system");
                                          
                                          break;
                                          
                                          
                                      default:
                                          
                                          NSLog(@"Authentication Failed");
                                          
                                          break;
                                  }
                              }
                              
                              
                          }
         
         
         ];
        
    } else {
        
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                        message:@"Device cannot authenticate using TouchID."
                                                       delegate:nil
                                              cancelButtonTitle:@"Ok"
                                              otherButtonTitles:nil];
        [alert show];
        
    }
}



@end
